#!/bin/bash
# Image builder template to reset the package repos to stock OS repos.
# origin: rackn/image-builder

######## this should only be run if requested, or if we have local-repos
######## set to true - as the local repos will not contain packages we
######## need for subsequent install tasks to succeed

{{ if eq ( .Param "image-builder/skip-package-reset") true -}}
echo "Skipping package repository reset task as specified by the skip param."
exit 0
{{ else -}}
echo "Beginning package repository reset - to disable set 'image-builder/skip-package-reset' to 'true'."
{{ end -}}

{{template "setup.tmpl" .}}

case $OS_FAMILY in
  rhel)
    source /etc/os-release
    echo "Identified RHEL variant as '$NAME'"
    rm -f /etc/yum.repos.d/00-rebar-base.repo
    yum -y clean all
    yum -y makecache

    case $NAME in
      "Red Hat Enterprise Linux Server")
        echo "Activate Redhat Subscription Manager repositories"
        {{ template "redhat-subscription-register.sh.tmpl" .}}
      ;;
      *)
        echo "Setting '$OS_TYPE' base repos back to default."
        yum -y reinstall $OS_TYPE-release
        #### TODO:  in the future, we want to give control over the
        ####        pkg installs to define local repos
        # Install EPEL repo - but if this failes, we don't want to
        # exit out, we'll try to manually get the EPEL rpm and install
        # that as a last ditch resort
        if ! yum -y install epel-release; then
          if ! curl -fgL \
              http://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm \
              -o /tmp/epel.rpm; then
          echo "Failed to get EPEL RPM"
          exit 1
        fi
            rpm -ivh /tmp/epel.rpm && rm -f /tmp/epel.rpm
        fi
      ;;
    esac
    ;;
  debian|ubuntu)
    echo "Setting '$OS_TYPE' '$OS_VER' base repos back to default."

    if [[ "$OS_TYPE" == "ubuntu" ]]
    then
      case $OS_VER in
        14.04) RELEASE="trusty"  ;;
        14.10) RELEASE="utopic"  ;;
        16.04) RELEASE="xenial"  ;;
        16.10) RELEASE="yakkety" ;;
        17.04) RELEASE="zesty"   ;;
        17.10) RELEASE="artful"  ;;
        18.04) RELEASE="bionic"  ;;
        18.10) RELEASE="cosmic"  ;;
        19.04) RELEASE="disco"   ;;
        19.10) RELEASE="eoan"    ;;
        20.04) RELEASE="focal"   ;;
        20.10) RELEASE="groovy"  ;;
        *) echo "Unable to reset repos for this version ... please fix me ... "
          exit 1
            ;;
      esac

      cat <<EOREPO > /etc/apt/sources.list
deb http://archive.ubuntu.com/ubuntu ${RELEASE} main multiverse restricted universe
deb http://archive.ubuntu.com/ubuntu ${RELEASE}-updates main restricted universe multiverse
deb http://archive.ubuntu.com/ubuntu ${RELEASE}-backports main restricted universe multiverse
deb http://security.ubuntu.com/ubuntu ${RELEASE}-security main restricted universe multiverse
EOREPO
    fi
    ;;
  photon)
    rm -f /etc/yum.repos.d/00-rebar-base.repo
    tdnf -y reinstall photon-release
    ;;
  *)
    echo "Sorry, no idea how to reset package repos for $OS_TYPE"
    exit 1
    ;;
esac

exit 0
